C For DOME density current problem (Ezer and Mellor,2004)
C ----------------------------------------------------------------------
      BLOCK DATA NISHAL
C ----------------------------------------------------------------------
      CHARACTER CASE*5,DSCRIB*63
      INCLUDE '../resolution.h'
      PARAMETER(IJ0=I0+J0,IJ1=IJ0-1,I1=I0-1,I2=I0-2,I3=I0-3,J1=J0-1,
     1 J2=J0-2,J3=J0-3,K1=K0-1,K2=K0-2,NB1=NB0-1)
      COMMON/CONTRO/DT,R0,TLZ,B,G,DM0,DE0,DMZ0,RZMX,TAU,TAUN,
     1 DRAG,FLTW,DAODT,DYDX,LRSTRT,MXIT,ISAV,
     2 MXSAV,LOPEN,LSURF,LSALT,LTURB,LWIND,LHEAT,LSAVE,
     3 LMOVI,LEVP,LCART,LBIN
      COMMON/LPI/M2,M6,MVI,IE(NB0)
      COMMON/TITLE/CASE,DSCRIB
      COMMON/ZFS/Z(K0+K1),ODZ(K1),ODZW(K0)
      DATA CASE/'sill '/
      DATA DSCRIB/
     1'DOME problem, w. specified east and north inflow, west outflow '/
      DATA DAODT,R0,B,G,DM0,DE0,DMZ0,RZMX,TAU,TAUN,DRAG,FLTW
C high dissipation
C    1/288.,6.4E8,2.E-4,980.,1.E6,1.E6,10.,20.,360.,1.,.002,.1/
C low dissipation
     1/144.,6.4E8,2.E-4,980.,5.E5,1.E5,.1,20.,360.,1.,.002,.1/
C To 40 days
      DATA LRSTRT,MXIT,ISAV,MXSAV/0,5760,144,144/
C Initial and boundary condition flags
      DATA LOPEN,LSURF,LCART,LBIN/1,0,0,0/
C Physical process flags
      DATA LSALT,LTURB,LWIND,LHEAT/0,0,0,0/
C Other flags
      DATA LSAVE,LMOVI,LEVP/1,0,1/
C Output control
      DATA M2,M6/1,1/

C EVP solver control
C IE(NB0)=J1
C We shift the solver arrays for second subdomain
C We initialize IE in DO LOOP 250 of SUBROUTINE INITFS
C     DATA IE/6,11,16,...,J1/

C ----------------------------
C EXPLANATION OF PARAMETERS
C ----------------------------
C I0,J0: horizontal dimension parameters (includes ghost zones around
C entire model domain; climatological boundary values are stored in
C ghost zones)
C K0: vertical dimension parameter (number of layer interfaces, equal
C the number of layers or pressure levels plus 1, does not include ghost
C zone)
C NB0: number of EVP elliptic solver restart vectors, used to control
C      solver roundoff error (decreases with increasing NB0)
C CASE=5-character case name
C DSCRIB=63-character case descriptor
C R0=earth radius

C TAU=surface restoring time in days
C TAUN=lateral boundary restoring time in days
C DAODT=number of time steps per day (8640 steps per year with DAODT=24)
C B=thermal expansion coefficient when linear equation of state is used
C G=gravity
C DM0,DE0 are horizontal heat and momentum diffusivities (cm-cm/sec)
C RZMX=vertical cell Reynolds number limit
C DRAG=drag coefficient (standard value is .002)
C FLTW=time filter coefficient on time filtered leapfrog method
C LRSTRT=flag to initialize from restart file; if LRSTRT=0, initial vel
C  is zero (but not necessarily boundary values)
C MXIT=last time step number of current run (last time step of previous
C run is saved on restart file)
C LOPEN=flag for open lateral boundaries (derive geostrophic inflows)
C LSURF=flag for including climatological top layer restoring
C      =0 means no restoring
C      =1 means TOP LAYER climatological restoring to Levitus
C      =2 stores climatological SURFACE T and S
C         for more sophisticated air-sea treatments
C LCART=flag to for Cartesian (non-spherical) option
C LBIN =flag to denote that input T and S are read from binary files
C LSALT,LTURB,LWIND,LHEAT,LSOL
C  flags for salinity, turbulence submodel, wind forcing,surface heating,
C  and interior radiative heating
C LSAVE=flag to save restart file
C LMOVI=flag to save data for animation of the results
C LEVP=flag for this program to initialize elliptic solver data for the
C  given geometry and also to generate initial temperature and salinity
C LSALT=flag for including salinity effects
C IE=array for EVP elliptic solver (controls roundoff error); IE(NB0)=J1
      END
C ----------------------------------------------------------------------
      PROGRAM PREP
C ----------------------------------------------------------------------
      INCLUDE '../resolution.h'
      PARAMETER(I1=I0-1,I2=I0-2,I3=I0-3,J1=J0-1,J2=J0-2,J3=J0-3,K1=K0-1,
     1 K2=K0-2)
      INTEGER*2 KB,KBM,IU0,IV0,IN,IU,IV,IW
      COMMON/CONTRO/DT,R0,TLZ,B,G,DM0,DE0,DMZ0,RZMX,TAU,TAUN,
     1 DRAG,FLTW,DAODT,DYDX,LRSTRT,MXIT,ISAV,
     2 MXSAV,LOPEN,LSURF,LSALT,LTURB,LWIND,LHEAT,LSAVE,
     3 LMOVI,LEVP,LCART,LBIN
      COMMON/SCA/ODT,PRN,ORZMX,OFLTW
      COMMON/METRICS/
     1 Y(J0),YV(J0),
     2 CS(J0),CSV(J1),OCS(J0),OCSV(J1),
     3 DX(J0),DXV(J1),ODX(J0),ODXV(J1),
     4 DY(J0),DYV(J1),ODY(J0),ODYV(J1)
      COMMON/TOPOG/KB(I0,J0),KBM(I0,J0),IU0(I0,J0),IV0(I0,J0),
     1 IN(I0,J0,K1),IU(I0,J0,K1),IV(I0,J1,K1),IW(I0,J0,K0)

C Input data: ETOPO5, Levitus (T and S)
C The model now reads input wind data directly
      COMMON/INPUTS/DEPTH(I0,J0)
C Output data:
C input data translated to model variable latitudinal resolution grid
      COMMON/GRIDAT/EV(I2,J2,K2),HV(I2,J2,K2),F(J2)
      COMMON/ZFS/Z(K0+K1),ODZ(K1),ODZW(K0)
      COMMON/BOYANC/T1(I0,J0,K1),S1(I0,J0,K1),D1(I0,J0,K1)
C ----------------
C INPUT DATA FILES
C ----------------
      OPEN(10,file='DATA/YZGRID',form='unformatted')
      OPEN(11,file='DATA/depth',form='unformatted')
C     IF (LEVP.EQ.0) GO TO 2
      OPEN(70,file='DATA/init0',form='unformatted')
      REWIND 70
C Read initial T and S data (for thermal wind in subroutine BOUNDS)
      READ(70) S1,T1
      CLOSE(70)
 
C -----------------
C OUTPUT DATA FILES
C -----------------
C BASIC RUN DATA
 2    OPEN(9,file='DATA/RUNDATA',form='unformatted')
      OPEN(17,file='KBVIEW')
      OPEN(60,file='DATA/ZKB',form='unformatted')
      OPEN(61,file='../MOVIE/DEPTH',form='unformatted')
      OPEN(62,FILE='DATA/boundaries',form='unformatted')
      REWIND 9
      REWIND 10
      REWIND 11
      REWIND 17
      REWIND 60
      REWIND 61
      REWIND 62
      IF (LEVP.EQ.0) GO TO 3
      OPEN(99,file='DATA/EVP',form='unformatted')
      REWIND 99
C ==============================================
C Read metrics data file YZGRID (from metrics.f)
C ==============================================
 3    READ(10) F,TLZ,Z,ODZ,ODZW,
     1 Y,YV,CS,CSV,OCS,OCSV,DX,DXV,ODX,ODXV,DY,DYV,ODY,ODYV

      K01=K0+K1
      WRITE(17,6) (Z(K),K=1,K01,2)
 6    FORMAT('Z-LEVELS(CM)'/(5(1X,1PE9.2)))

C ===============
C Read DEPTH data
C ===============
C DEPTH(I,1) corresponds to southern most internal grid point
      READ(11) DEPTH
C BD97 sill proglem
C Convert to cm
      DO 33 J=2,J1
      DO 33 I=2,I1
 33   DEPTH(I,J)=MIN(TLZ,100.*DEPTH(I,J))
C ================================================
C Determine "logical grid" depth array KB(I,J)
C KB(I,J)=number of layers at pressure point (I,J)
C ================================================
      DO 34 K=1,K1
      ZZ=.5*(Z(2*K-1)+Z(2*K+1))
      DO 34 J=2,J1
      DO 34 I=2,I1
C If DEPTH is deeper than mid-layer (ZZ), increment KB by 1
      L=DEPTH(I,J)/ZZ
 34   KB(I,J)=KB(I,J)+MIN(1,L)
C ==========================
C Derive land/sea mask array
C ==========================
      DO 52 J=2,J1
      DO 52 I=2,I1
      IT=KB(I,J)
      IF (IT.NE.0) GO TO 50
      KB(I,J)=1
      GO TO 52
 50   DO 51 K=1,IT
 51   IN(I,J,K)=1
 52   CONTINUE

      DO 53 K=1,K1
 53   WRITE(*,54) (IN(I0/2,J,K),J=2,J1)
 54   FORMAT(220I1)

C OTHER MASK ARRAYS
      DO 65 K=1,K1
      DO 64 J=1,J0
      DO 64 I=1,I1
 64   IU(I,J,K)=IN(I,J,K)*IN(I+1,J,K)
      DO 65 J=1,J1
      DO 65 I=1,I0
 65   IV(I,J,K)=IN(I,J,K)*IN(I,J+1,K)
      DO 66 K=1,K2
      DO 66 J=1,J0
      DO 66 I=1,I0
 66   IW(I,J,K+1)=IN(I,J,K)*IN(I,J,K+1)
      DO 76 J=2,J1
      DO 76 I=2,I2
      IU0(I,J)=IU(I,J,1)
 76   IU(I,J,1)=1
      DO 77 J=2,J2
      DO 77 I=2,I1
      IV0(I,J)=IV(I,J,1)
 77   IV(I,J,1)=1
      WRITE(60) TLZ,Z,ODZ,ODZW,KB,IN,IU,IV,IW,IU0,IV0
      WRITE(60) DEPTH
      WRITE(61) DEPTH
C DOME density current problem patterned after Ezer and Mellor
C domain width=1100km
      ILO=8.*I2/11
      IHI=9.*I2/11
C 600m depth sill, total depth is 2200m
      N=6.*K1/22.
      TMAX=15.
      TINC=(-10.*22./36.)/N
      DO 90 K=1,N
      ZZ=.01*Z(2*K)
C TDIF=5 at K=N (ZZ=600.); TDIF=5/E at ZZ=0.
C     TDIF=5.*EXP((ZZ-600.)/600.)
      TDIF=5.*EXP((ZZ-600.)/600.)
      TMP=TDIF/(IHI-ILO)
      DO 80 I=ILO,IHI
 80   T1(I,J0,K)=TMAX-TMP*(IHI-I)
      DO 81 I=2,ILO
 81   T1(I,J0,K)=T1(ILO,J0,K)
      DO 82 I=IHI+1,I1
 82   T1(I,J0,K)=T1(IHI,J0,K)
 90   TMAX=TMAX+TINC

      DO 95 K=1,N
      WRITE(17,86) K,(T1(I,J1,K)-T1(I,J0,K),I=ILO-1,IHI+1)
      WRITE(*,86) K,(T1(I,J1,K)-T1(I,J0,K),I=ILO-1,IHI+1)
 86   FORMAT('T1(I,J1,K)-T1(I,J0,K), at K=',I3/(11F5.1))
 95   CONTINUE
      DO 99 K=1,N
      WRITE(17,85) K,(T1(I,J0,K),I=ILO-1,IHI+1)
      WRITE(*,85) K,(T1(I,J0,K),I=ILO-1,IHI+1)
 85   FORMAT('inflow T at K=',I3/(11F5.1))
 99   CONTINUE
      pause1

C Add east inflow (North Atlantic Gyre)
c     DO 124 K=1,K1
c     ZZ=.01*Z(2*K)
c     TMP=(EXP(-ZZ/100.)-0.1*EXP(ZZ/2200.))/(J0-3)
c     DO 120 J=2,J1
c120  T1(I0,J,K)=T1(I0,J,K)-(J-2)*TMP
c     WRITE(*,122) K,(T1(I0,J,K),J=2,J0-6,5)
c124  WRITE(17,122) K,(T1(I0,J,K),J=2,J0-6,5)
c122  FORMAT('level ',I3,' East inflow temperature'/(15F5.1))
c     pause2
      OPEN(70,file='DATA/initial',form='unformatted')
      REWIND 70
      WRITE(70) S1,T1
      CLOSE(70)
C     -----------
      CALL INITFS
C     -----------
      END
C ----------------------------------------------------------------------
      SUBROUTINE PRE(AX,AY,BB,CX,CY,RINV,RINV1,H,IE,M0,M2,NBLK)
C ----------------------------------------------------------------------
      REAL*8 RINV,RINV1,H,RUN
      DIMENSION AX(M2,1),AY(M2,1),BB(M2,1),CX(M2,1),CY(M2,1),
     1 RINV(M2,M2,1),RINV1(M2,M2,1),H(M0,1),IE(1)
      JL=1
      NB=0
 100  NB=NB+1
      WRITE(*,111) NB,NBLK
 111  FORMAT
     1 ('Processing block #',I3,' out of',I3,' total evp solver blocks')
      JH=IE(NB)
      JHP=JH+1
      JHM=JH-2
      JG=JL+1
      DO 250 NG=1,M2
      IG=NG+1
      DO 210 J=JL,JHP
      DO 210 I=1,M0
 210  H(I,J)=0.
      H(IG,JG)=1.
      IF (NB.EQ.1) GO TO 220
      DO 218 N=1,M2
 218  H(N+1,JL)=RINV1(NG,N,NB-1)*CY(IG-1,JG-2)
 220  DO 225 J=JL,JHM
      DO 225 I=1,M2
 225  H(I+1,J+2)=-(AX(I,J)*H(I,J+1)+AY(I,J)*H(I+1,J)+BB(I,J)*H(I+1,J+1)+
     1 CX(I,J)*H(I+2,J+1))/CY(I,J)
      J=JH-1
      DO 230 I=1,M2
 230  RINV(NG,I,NB)=AX(I,J)*H(I,J+1)+AY(I,J)*H(I+1,J)+BB(I,J)*
     1 H(I+1,J+1)+CX(I,J)*H(I+2,J+1)
      IF (NB.EQ.NBLK) GO TO 250
      J=IE(NB)
      DO 240 N=1,M2
 240  RINV(NG,N,NBLK)=H(N+1,J)
 250  H(IG,JG)=0.
      CALL MATINV(RINV(1,1,NB),M2)
      IF (NB.EQ.NBLK) RETURN
      DO 260 I=1,M2
      DO 260 J=1,M2
      RINV1(I,J,NB)=0.
      DO 260 K=1,M2
 260  RINV1(I,J,NB)=RINV1(I,J,NB)-RINV(I,K,NB)*RINV(K,J,NBLK)
      JL=JH
      GO TO 100
      END
C ----------------------------------------------------------------------
      SUBROUTINE MATINV(B,N)
C ----------------------------------------------------------------------
      INCLUDE '../resolution.h'
      PARAMETER(I2=I0-2)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION B(N,1),B1(I2),B2(I2)
      N1=N-1
      DO 135 I=1,N1
      B1(1)=1./B(I,I)
      B(I,I)=1.0
      DO 112 J=1,N
 112  B(I,J)=B(I,J)*B1(1)
      IP1=I+1
      DO 120 IA=IP1,N
 120  B1(IA)=B(IA,I)
      DO 125 IA=IP1,N
 125  B(IA,I)=0.
      DO 127 J=1,N
 127  B2(J)=B(I,J)
      DO 135 IA=IP1,N
      DO 135 J=1,N
 135  B(IA,J)=B(IA,J)-B1(IA)*B2(J)
      B1(1)=1./B(N,N)
      B(N,N)=1.
      DO 140 J=1,N
 140  B(N,J)=B(N,J)*B1(1)
      DO 160 I=2,N
      DO 155 IB=1,I
 155  B1(IB)=B(IB,I)
      IM1=I-1
      DO 156 IB=1,IM1
 156  B(IB,I)=0.
      DO 157 J=1,N
 157  B2(J)=B(I,J)
      IM1=I-1
      DO 160 IB=1,IM1
      DO 160 J=1,N
 160  B(IB,J)=B(IB,J)-B1(IB)*B2(J)
      END
C ----------------------------------------------------------------------
      SUBROUTINE BOUNDS
C ----------------------------------------------------------------------
      INCLUDE '../resolution.h'
      PARAMETER(I1=I0-1,I2=I0-2,I3=I0-3,J1=J0-1,J2=J0-2,J3=J0-3,K1=K0-1,
     1 K2=K0-2)
      INTEGER*2 KB,KBM,IU0,IV0,IN,IU,IV,IW
      COMMON/INPUTS/DEPTH(I0,J0)
      COMMON/CONTRO/DT,R0,TLZ,B,G,DM0,DE0,DMZ0,RZMX,TAU,TAUN,
     1 DRAG,FLTW,DAODT,DYDX,LRSTRT,MXIT,ISAV,
     2 MXSAV,LOPEN,LSURF,LSALT,LTURB,LWIND,LHEAT,LSAVE,
     3 LMOVI,LEVP,LCART,LBIN
      COMMON/SCA/ODT,PRN,ORZMX,OFLTW
      COMMON/TOPOG/KB(I0,J0),KBM(I0,J0),IU0(I0,J0),IV0(I0,J0),
     1 IN(I0,J0,K1),IU(I0,J0,K1),IV(I0,J1,K1),IW(I0,J0,K0)
      COMMON/ZFS/Z(K0+K1),ODZ(K1),ODZW(K0)
      COMMON/GRIDAT/EV(I2,J2,K2),HV(I2,J2,K2),F(J2)
      COMMON/BOYANC/T1(I0,J0,K1),S1(I0,J0,K1),D1(I0,J0,K1)
      COMMON/BVEL/UEST(J0,K1),UWST(J0,K1),VNOR(I0,K1),VSUD(I0,K1),
     1 SVWST(K1),SVNOR(K1),SVSUM(K1),SVIN,AROUT
      COMMON/METRICS/
     1 Y(J0),YV(J0),
     2 CS(J0),CSV(J1),OCS(J0),OCSV(J1),
     3 DX(J0),DXV(J1),ODX(J0),ODXV(J1),
     4 DY(J0),DYV(J1),ODY(J0),ODYV(J1)

CALCULATE DENSITIES
      DMIN=1.E10
      DMAX=-1.E10
      DO 326 K=1,K1
      DO 326 J=1,J0
      DO 326 I=1,I0
      RHO=.0002*(20.-T1(I,J,K))
      DMIN=MIN(DMIN,RHO)
      DMAX=MAX(DMAX,RHO)
 326  D1(I,J,K)=RHO
      WRITE(17,327) DMIN,DMAX
      WRITE(*,327) DMIN,DMAX
 327  FORMAT('DMIN,DMAX=',2(1X,F9.4))
      SVIN=0.

      N=5.*K1/22.
      ILO=8.*I2/11
      IHI=9.*I2/11
C DERIVE GEOSTROPHIC INFLOWS BY VERTICALLY INTEGRATING HYDROSTATIC EQUATION
      DO 330 K=2,N

C DOME problem
      DO 330 I=ILO-1,IHI+1
C NORTH
      DDDX=.25*ODXV(J1)*
     1 (D1(I+1,J0,K)-D1(I-1,J0,K)+D1(I+1,J0,K-1)-D1(I-1,J0,K-1))
C     VNOR(I,K-1)=VNOR(I,K)-IN(I,J1,K-1)*G*DDDX/(F(J2)*ODZW(K))
      VNOR(I,K)=IN(I,J1,K)*(VNOR(I,K-1)+G*DDDX/(F(J2)*ODZW(K)))
 330  SVIN=SVIN-VNOR(I,K)*DXV(J1)/ODZ(K)

      DO 340 K=1,N+1
      WRITE(17,342) K,(INT(-10.*VNOR(I,K)),I=ILO,IHI)
 340  WRITE(*,342) K,(INT(-10.*VNOR(I,K)),I=ILO,IHI)
 342  FORMAT('K=',I2/(21I4))
      SVIN=1.E-12*SVIN
      WRITE(17,344) SVIN
      WRITE(*,344) SVIN
 344  FORMAT('northern inflow velocity (mm/sec)'/
     1 'total northern inflow=',F6.2, 'Sv')

      SV=0.
      DO 345 J=2,J1
C345  UEST(J,1)=-2.
 345  UEST(J,1)=0.
      DO 347 K=2,K1
      DO 346 J=3,J2
c EAST
      DDDY=.25*ODY(J)*
     1 (D1(I0,J+1,K)-D1(I0,J-1,K)+D1(I0,J+1,K-1)-D1(I0,J-1,K-1))
c UINC=GB*DTDY*DZ/F
      UEST(J,K)=IN(I1,J,K)*(UEST(J,K-1)-G*DDDY/(F(J-1)*ODZW(K)))
 346  SV=SV-UEST(J,K)*DY(J)/ODZ(K)
      UEST(2,K)=UEST(3,K)
      UEST(J1,K)=UEST(J2,K)
 347  SV=SV-(UEST(2,K)*DY(2)+UEST(J1,K)*DY(J1))/ODZ(K)
      SV=1.E-12*SV
      SVIN=SVIN+SV
      WRITE(17,355) SV,SVIN
      WRITE(*,355) SV,SVIN
 355  FORMAT(F4.1,' Sv eastern inflow added for a total of ',F4.1,
     1 'Sv inflow.')
      pause3
      DO 358 K=1,K1
      WRITE(17,359) K,(INT(-10.*UEST(J,K)),J=2,J1,5)
 358  WRITE(*,359) K,(INT(-10.*UEST(J,K)),J=2,J1,5)
 359  FORMAT(/'level',I3,' east inflow velocity (mm/sec)'/(25I4))
      pause4
      AROUT=0.
      DO 360 J=2,J1
 360  AROUT=AROUT+DY(J)*(Z(2*KB(I,J)+1)-Z(1))
      WRITE(62) AROUT
      WRITE(62) UEST,UEST,UWST,UWST,VNOR,VNOR,VSUD,VSUD
      END
C ----------------------------------------------------------------------
      SUBROUTINE INITFS
C INITFS Initializes all controlling arrays and derived scalars
C(scalar control parameters are set in BLOCK DATA at start of this file)
C ----------------------------------------------------------------------
      INCLUDE '../resolution.h'
      PARAMETER(IJ0=I0+J0,IJ1=IJ0-1,I1=I0-1,I2=I0-2,I3=I0-3,J1=J0-1,
     1 J2=J0-2,J3=J0-3,K1=K0-1,K2=K0-2,NB1=NB0-1)
      REAL*8 RINV,RINV1,DUM0,DUM1,DUM2,X,H
      CHARACTER CASE*5,DSCRIB*63
      INTEGER*2 KB,KBM,IU0,IV0,IN,IU,IV,IW
      COMMON/GRIDAT/EV(I2,J2,K2),HV(I2,J2,K2),F(J2)
      COMMON/CONTRO/DT,R0,TLZ,B,G,DM0,DE0,DMZ0,RZMX,TAU,TAUN,
     1 DRAG,FLTW,DAODT,DYDX,LRSTRT,MXIT,ISAV,
     2 MXSAV,LOPEN,LSURF,LSALT,LTURB,LWIND,LHEAT,LSAVE,
     3 LMOVI,LEVP,LCART,LBIN
      COMMON/SCA/ODT,PRN,ORZMX,OFLTW
      COMMON/METRICS/
     1 Y(J0),YV(J0),
     2 CS(J0),CSV(J1),OCS(J0),OCSV(J1),
     3 DX(J0),DXV(J1),ODX(J0),ODXV(J1),
     4 DY(J0),DYV(J1),ODY(J0),ODYV(J1)
      COMMON/SEVP/RINV(I2,I2,NB0),RINV1(I2,I2,NB1),DUM0(I2,NB1),
     1 DUM1(I2),DUM2(I2),X(I0,J0),H(I0,J0),AL(I2,J2),AB(I2,J2),
     2 AC(I2,J2),AR(I2,J2),AT(I2,J2)
      COMMON/TOPOG/KB(I0,J0),KBM(I0,J0),IU0(I0,J0),IV0(I0,J0),
     1 IN(I0,J0,K1),IU(I0,J0,K1),IV(I0,J1,K1),IW(I0,J0,K0)
      COMMON/ZFS/Z(K0+K1),ODZ(K1),ODZW(K0)
      COMMON/LPI/M2,M6,MVI,IE(NB0)
      COMMON/TITLE/CASE,DSCRIB
 
      DT=172800./DAODT
      ODT=1./DT
      ORZMX=1./RZMX
      OFLTW=1.-FLTW
      M2=M2*DAODT
      M6=M6*DAODT
      MVI=0.25*DAODT
      PRN=DE0/DM0

C ----------------------------------
C SET INITIAL VERTICAL DIFFUSIVITIES
C ----------------------------------
C NOTE THAT EV AND HV ARE WEIGHTED BY 1/DZ
      TL=1.
      DO 88 K=1,K2
C SET VERTICAL DIFFUSIVITIES TO TL AND DE0/DM0*TL CM**2/SEC
      TMP=TL*DMZ0*ODZW(K+1)
      TEMP=PRN*TMP
      DO 88 J=1,J2
      DO 88 I=1,I2
      EV(I,J,K)=TMP*IW(I+1,J+1,K+1)
 88   HV(I,J,K)=TEMP*IW(I+1,J+1,K+1)

C KTRM=sill level (used only for animation graphics)
      KTRM=5.*K1/22.

      WRITE(9) CASE,DSCRIB,DT,TLZ,B,G,DM0,DE0,DMZ0,EV,HV,F,
     1 RZMX,TAU,TAUN,DRAG,FLTW,DAODT,ODT,
     2 PRN,ORZMX,OFLTW,Y,YV,CS,CSV,OCS,OCSV,DX,DXV,
     3 ODX,ODXV,DY,DYV,ODY,ODYV,KTRM,LRSTRT,MXIT,ISAV,MXSAV,M2,M6,LOPEN,
     4 LSURF,LTURB,LWIND,LHEAT,LSAVE,LMOVI,MVI

      IF (LEVP.NE.1) STOP
      CALL BOUNDS
      DO 250 N=1,NB0
 250  IE(N)=1+5*N

C -------------------------------------------------
C PREPROCESSOR FOR ELLIPTIC SOLVER USED TO MAINTAIN
C INCOMPRESSIBILITY FOR RIGID-LID HYDROSTATIC FLOWS
C -------------------------------------------------
C First, do top layer (all water to regularize EVP domain)
      TMP=1./ODZ(1)
      DO 280 J=1,J2
      DZX=ODX(J+1)**2*TMP
      DZYB=CSV(J)*OCS(J+1)*ODYV(J)*ODY(J+1)*TMP
      DZYT=CSV(J+1)*OCS(J+1)*ODYV(J+1)*ODY(J+1)*TMP
      DO 280 I=1,I2
      AL(I,J)=DZX
      AR(I,J)=DZX
      AB(I,J)=DZYB
 280  AT(I,J)=DZYT
C Remaining layers
      DO 282 K=2,K1
      TMP=1./ODZ(K)
      DO 282 J=1,J2
      DZX=ODX(J+1)**2*TMP
      DZYB=CSV(J)*OCS(J+1)*ODYV(J)*ODY(J+1)*TMP
      DZYT=CSV(J+1)*OCS(J+1)*ODYV(J+1)*ODY(J+1)*TMP
      DO 282 I=1,I2
      AL(I,J)=AL(I,J)+DZX*IU(I,J+1,K)
      AR(I,J)=AR(I,J)+DZX*IU(I+1,J+1,K)
      AB(I,J)=AB(I,J)+DZYB*IV(I+1,J,K)
 282  AT(I,J)=AT(I,J)+DZYT*IV(I+1,J+1,K)
      DO 284 J=1,J2
      AL(1,J)=0.
 284  AR(I2,J)=0.
      DO 286 I=1,I2
      AB(I,1)=0.
 286  AT(I,J2)=0.
C Pin down pressure
      AB(I2/2,1)=AB(I2/2,2)
      DO 287 J=1,J2
      DO 287 I=1,I2
 287  AC(I,J)=-AL(I,J)-AR(I,J)-AB(I,J)-AT(I,J)
      WRITE(*,295)
 295  FORMAT('ENTER EVP PREPROCESSOR')
      CALL PRE(AL,AB,AC,AR,AT,RINV,RINV1,H,IE,I0,I2,NB0)
      WRITE(99) AL,AR,AB,AT,AC,RINV,RINV1,IE
      END
