      PROGRAM XZPLTS
      INCLUDE '../resolution.h'
      PARAMETER(L0=9999,I1=I0-1,I2=I0-2,I3=I0-3,
     1 J1=J0-1,J2=J0-2,J3=J0-3,K1=K0-1,K2=K0-2,K3=K0-3)
      CHARACTER*1 FYZ
      CHARACTER CASE*5,DSCRIB*63,FN*1,FNAME*30,NAME*50
      INTEGER*2 NX1,NX2,NZ1,NZ2,NCN,IN,INVERT,INXZ
C PLOT WINDOW IS SCALED BY LOGICAL (GRID) COORDINATES
C ALL FIELDS ARE ASSUMED AT SCALAR CELL CENTERS
      COMMON/FIELDS/FLD(I0,K1),P(I0,K1),U(I0,K1),W(I0,K1),DUM(I0,K1),
     1 IN(I0,J0,K1),INVERT(I0,J0,K1),INXZ(I0,K1)
      COMMON/PHYS/FYZ
      COMMON/FIXED/ODX(J0),ODY(J0),Z(K0+K1),ZFLIP(K0+K1),ODZ(K1),
     1 ODZW(K0)
      COMMON/LABELS/CASE
      COMMON/LINSAV/XLO,XHI,ZLO,ZHI,XCON,ZCON,LINES,MAXCV,
     1 NX1(L0),NX2(L0),NZ1(L0),NZ2(L0),NCN(L0)
      COMMON/CON/TIME,FMIN,FMAX,IMN,KMN,IMX,KMX
      COMMON/TRANZ/ZW(K0),ZFYZ
      DIMENSION YDEG(J0)
      DATA NINT,NOFLT,FYZ/11,0,'Y'/
 
      OPEN(4,file='LINES')
C INPUT FIELD DATA
      OPEN(31,file='DATA',form='unformatted')
C OUTPUT PLOTS DATA
      PRINT*, 'Output graphics data is denoted as unformatted (binary).'
      OPEN(24,file='GRID',form='unformatted')
      OPEN(34,file='OBSTACLES',form='unformatted')
      OPEN(25,file='CONVEC',form='unformatted')
      REWIND 4
      REWIND 24
      REWIND 34
      REWIND 25
      REWIND 30

      DO 10 J=2,J1
 10   YDEG(J)=45.+(J-2)/30.

      READ(31) CASE,DSCRIB,LRSTRT,MXIT,I,J,K,INVERT,ODX,ODY,ODZ,ZFLIP
C TURN DATA OVER (SO THAT FIRST LEVEL IS AT BOTTOM)
      N=K0+K1
      DO 15 K=1,K0+K1
 15   Z(K)=ZFLIP(N-K+1)
      DO 16 K=1,K1
      N=K1-K+1
      DO 16 J=1,J0
      DO 16 I=1,I0
 16   IN(I,J,K)=INVERT(I,J,N)

      WRITE(*,22) CASE,DSCRIB,I,J,K,.00001/ODX(J0/2),.00001/ODY(J0/2),
     1 (.01*Z(N),N=1,K0+K1,2)
      WRITE(4,22) CASE,DSCRIB,I,J,K,.00001/ODX(J0/2),.00001/ODY(J0/2),
     1 (.01*Z(N),N=1,K0+K1,2)
 22   FORMAT('Case ',A5/A63/'I0,J0,K0,ODX(J0/2),ODY(J0/2):',
     1 3I3,F5.1,' km,',F5.1,' km'/'layer interface depths (m)'/(10F8.2))

      XLO=0.
C     DO 27 J=1,J0
C27   WRITE(*,28) (IN(I,J,1),I=2,I1)
C28   FORMAT(130I1)
C     ZLO=0.
C LEAVE LOWER 1/20 OF PLOT WINDOW FOR TEXT
      ZLO=-K1/20.
      XHI=I2
      ZHI=K1
      XCON=9999./(XHI-XLO)
      ZCON=9999./(ZHI-ZLO)
      DO 30 K=1,K0
 30   ZW(K)=Z(1)-Z(2*K-1)
      ZFYZ=ZHI/(ZW(K0)-ZW(1))
      WRITE(*,31) ZFYZ,ZW
 31   FORMAT(5(1X,1PE9.2))
      MAXCV=0
      LINES=0
      CALL GRID(0,0,I2,K1)
      WRITE(4,59) LINES
 59   FORMAT('M0= ',I4,' (LINES REQUIRED FOR GRID TICKS)')
      WRITE(24) LINES,(NX1(L),NX2(L),NZ1(L),NZ2(L),L=1,LINES)
      CLOSE(24)
C OBSTACLES
C OPTIONALLY, SMOOTH BORDER CAN BE DRAWN BY CONTOURING APPROPRIATE FLAG ARRAY
      MAXOB=0
      DO 80 J=2,J1
      LINES=0
      DO 75 K=1,K1
      DO 75 I=2,I1
 75   INXZ(I,K)=IN(I,J,K)
      CALL BLOKS(INXZ)
      MAXOB=MAX(MAXOB,LINES)
      WRITE(34) LINES,(NX1(L),NX2(L),NZ1(L),NZ2(L),L=1,LINES)
 80   CONTINUE
      WRITE(4,81) MAXOB
 81   FORMAT('L0= ',I4,' (LINES REQUIRED FOR OBSTACLES)')
      CLOSE(34)
      NPLOT=0
 100  LINES=0
 101  CALL INPUT(NPLOT,FLD,FN,J,FNAME)
      N=TIME+0.1
      IF (FN.EQ.'P'.OR.MOD(N,5).NE.0) GO TO 101
      DO 102 K=1,K1
      DO 102 I=2,I1
 102  INXZ(I,K)=IN(I,J,K)
      IF (NOFLT.EQ.1) GO TO 1050
C X-DIRECTIONAL FILTER
      CALL FLTX(0.,FLD,DUM,INXZ)
C Z-DIRECTIONAL FILTER
      CALL FLTZ(0.,FLD,DUM,INXZ)
C CONTOURS
C Damp deep w to focus on upper layers convection
 1050 IF (FN.NE.'w') GO TO 105
      FMIN=1.E6
      FMAX=-1.E6
      TMP=1.
      DO 1111 K=K1,1,-1

C     IF (K.LT.14) TMP=.8*TMP

      DO 1111 I=1,I0
      IF (INXZ(I,K).EQ.0) GO TO 1111
      FLD(I,K)=TMP*FLD(I,K)
      FMIN=MIN(FMIN,FLD(I,K))
      FMAX=MAX(FMAX,FLD(I,K))
 1111 CONTINUE
      WRITE(*,2221) FMIN,FMAX
 2221 FORMAT('Wmin, Wmax: ',1P,2(1X,E8.1))
      CALL CONXZ(FLD,INXZ,.5,.5,I0,2,1,I1,K1,0.05,5,1,FMIN,FMAX,10)
      GO TO 120
 105  IF (FN.EQ.'T')
     1 CALL CONXZ(FLD,INXZ,.5,.5,I0,2,1,I1,K1,0.1,5,1,-10.,89.,99)
      IF (FN.EQ.'R')
     1 CALL CONXZ(FLD,INXZ,.5,.5,J0,2,1,I1,K1,0.05,5,1,0.,99.,99)
      IF (FN.EQ.'U'.OR.FN.EQ.'V'.OR.FN.EQ.'s')
     1 CALL CONXZ(FLD,INXZ,.5,.5,I0,2,1,I1,K1,0.1,5,1,-295.,295.,59)
      IF (FN.EQ.'w')
     1 CALL CONXZ(FLD,INXZ,.5,.5,J0,2,1,I1,K1,0.05,5,1,-900.,900.,9)
 120  NPLOT=NPLOT+1
      MAXCV=MAX(LINES,MAXCV)
      TMP=YDEG(J)
      WRITE(NAME,121) FNAME,TMP
 121  FORMAT(A30,' at ',F5.1, ' deg. lat.')
      WRITE(25)
     1 J,FN,NAME,TIME,FMIN,FMAX,IMN,KMN,IMX,KMX,NINT,
     2 LINES,(NX1(L),NX2(L),NZ1(L),NZ2(L),NCN(L),L=1,LINES)
 132  FORMAT(I2,A1,A50,3E10.3,4I3,I5/(20I4))
      WRITE(*,200) NPLOT,MAXCV
 200  FORMAT('NPLOT,MAXCV',2I6)
      GO TO 100
      END
C ----------------------------------------------------------------------
      SUBROUTINE GRID(IL,KL,IH,KH)
C ----------------------------------------------------------------------
C THIS MODULE DRAWS RECTANGULAR BOUNDARY AND GRID TICK MARKS
      INCLUDE '../resolution.h'
      PARAMETER(L0=9999,I1=I0-1,I2=I0-2,I3=I0-3,
     1 J1=J0-1,J2=J0-2,J3=J0-3,K1=K0-1,K2=K0-2,K3=K0-3)
      COMMON/FIXED/ODX(J0),ODY(J0),Z(K0+K1),ODZ(K1),ODZW(K0)
      DIMENSION XPT(5),ZPT(5)
      XPT(1)=IL
      ZPT(1)=KL
      XPT(2)=IH
      ZPT(2)=KL
      XPT(3)=IH
      ZPT(3)=KH
      XPT(4)=IL
      ZPT(4)=KH
      XPT(5)=IL
      ZPT(5)=KL
CPLT DRAW RECTANGULAR PLOT BOUNDARY (FOUR STRAIGHT LINES,
C LAST POINT = FIRST POINT)
      DO 4 L=1,4
 4    CALL GRAPH(XPT(L),ZPT(L))
      KHM=KH-1
      IHM=IH-1
      ILP=IL+1
      KLP=KL+1
CPLT DRAW TICK MARKS ON PLOT BOUNDARY TO SHOW GRID SPACING
      TICK=.5
      ZPT(1)=KL
      ZPT(2)=TICK
      ZPT(3)=KH
      ZPT(4)=KH-TICK
      XPT(1)=IL
      XPT(2)=TICK
      XPT(3)=IH
      XPT(4)=IH-TICK
      DO 6 K=KLP,KHM
      ZPT(1)=K
      ZPT(2)=K
CPLT DRAW RIGHT AND LEFT TICK MARKS
      CALL GRAPH(XPT,ZPT)
 6    CALL GRAPH(XPT(3),ZPT)
      END
C ----------------------------------------------------------------------
      SUBROUTINE BLOKS(INXZ)
C ----------------------------------------------------------------------
C THIS MODULE DRAWS STAIRCASE BOUNDARIES AND CROSS-HATCHES BLOCKED AREAS
C OPTIONALLY, STAIRCASE COULD BE DONE BY CONTOURING FLAG ARRAYS
      INCLUDE '../resolution.h'
      PARAMETER(L0=9999,I1=I0-1,I2=I0-2,I3=I0-3,
     1 J1=J0-1,J2=J0-2,J3=J0-3,K1=K0-1,K2=K0-2,K3=K0-3)
      INTEGER*2 INXZ
      COMMON/FIXED/ODX(J0),ODY(J0),Z(K0+K1),ODZ(K1),ODZW(K0)
      DIMENSION INXZ(I0,K1),XPT(5),ZPT(5)

C Staircase lines
      DO 28 K=1,K1
      DO 28 I=0,I1
C Z-levels
C Must be done cell-by-cell to appear in zooms made in plots.f
C Don't draw line segment if cell above is land
      IF (INXZ(I+2,K).EQ.1) GO TO 17
      XPT(1)=I
      XPT(2)=I+1
      ZPT(1)=K
      ZPT(2)=ZPT(1)
      CALL GRAPH(XPT,ZPT)
 17   IF (I.EQ.0.OR.INXZ(I,K)+INXZ(I+1,K).NE.1) GO TO 18
      XPT(1)=I-1.
      XPT(2)=XPT(1)
      ZPT(1)=K-1.
      ZPT(2)=K
      CALL GRAPH(XPT,ZPT)
 18   CONTINUE
C resolution 1/2 deg
C draw lines at even multiples of 10 deg longitude
      IF (K.NE.1.OR.MOD(I,10).NE.9) GO TO 28
      XPT(1)=I+1
      XPT(2)=XPT(1)
      ZPT(1)=0.
      ZPT(2)=0.25
Cross-grid
C     ZPT(2)=K1
      CALL GRAPH(XPT,ZPT)
 28   CONTINUE
      END
C ----------------------------------------------------------------------
      SUBROUTINE FLTX(PWT,P,S,IN)
C BIHARMONIC FILTER
C ----------------------------------------------------------------------
      INCLUDE '../resolution.h'
      PARAMETER(I1=I0-1,K2=K0-2)
      INTEGER*2 IN(I0,1)
      DIMENSION P(I0,1),S(I0,1)
      TMP=(1.-PWT)/16.
      DO 40 K=2,K2
      DO 20 I=2,I1
 20   S(I,K)=IN(I,K)*(IN(I-1,K)*P(I-1,K)+IN(I+1,K)*P(I+1,K)
     1 -(IN(I-1,K)+IN(I+1,K))*P(I,K))
      DO 40 I=2,I1
 40   P(I,K)=P(I,K)-TMP*IN(I,K)*(IN(I-1,K)*S(I-1,K)+IN(I+1,K)*S(I+1,K)
     1 -(IN(I-1,K)+IN(I+1,K))*S(I,K))
      END
C ----------------------------------------------------------------------
      SUBROUTINE FLTZ(PWT,P,S,IN)
C BIHARMONIC FILTER
C ----------------------------------------------------------------------
      INCLUDE '../resolution.h'
      PARAMETER(I1=I0-1,K2=K0-2)
      INTEGER*2 IN(I0,1)
      DIMENSION P(I0,1),S(I0,1)
      TMP=(1.-PWT)/16.
      DO 40 I=2,I1
      DO 20 K=2,K2
 20   S(I,K)=IN(I,K)*(IN(I,K-1)*P(I,K-1)+IN(I,K+1)*P(I,K+1)
     1 -(IN(I,K-1)+IN(I,K+1))*P(I,K))
      DO 40 K=2,K2
 40   P(I,K)=P(I,K)-TMP*IN(I,K)*(IN(I,K-1)*S(I,K-1)+IN(I,K+1)*S(I,K+1)
     1 -(IN(I,K-1)+IN(I,K+1))*S(I,K))
      END
C ----------------------------------------------------------------------
      SUBROUTINE CONXZ(FLD,IN,XBRD,YBRD,IR,IL,JL,IH,JH,EPS,IMSK,JMSK,
     1 RMIN,RMAX,NINT)
C ----------------------------------------------------------------------
C THIS MODULE CONTOURS HORIZONTAL (XY) CROSS-SECTIONS
      INCLUDE '../resolution.h'
      PARAMETER(L0=9999,I1=I0-1,I2=I0-2,I3=I0-3,
     1 J1=J0-1,J2=J0-2,J3=J0-3,K1=K0-1,K2=K0-2,K3=K0-3)
      INTEGER*2 NX1,NX2,NZ1,NZ2,NCN,IN

      PARAMETER(LB0=99)
C NINT < LBS dimension!
      CHARACTER*6 LBS(LB0)

      COMMON/SCRTCH/SCLN(I0,2)
      COMMON/SC/SEGMX(I0),SEGMN(I0),CELMX(I1),CELMN(I1),ZERO(I1),
     1 MXCEL(I1),MNCEL(I1)
      COMMON/CON/TIME,FMIN,FMAX,IMN,KMN,IMX,KMX
      COMMON/LINSAV/XLO,XHI,ZLO,ZHI,XCON,ZCON,LINES,MAXCV,
     1 NX1(L0),NX2(L0),NZ1(L0),NZ2(L0),NCN(L0)
      DIMENSION MASK(I0,K0),FLD(IR,1),IN(IR,1),XPT(5),YPT(5)

C ============
Contour labels
C ============
C Write LBS content (later use contour values based on RMIN,RMAX,NINT)
      IF (NINT.GT.LB0) stop0
      IF (RMAX-RMIN.LT.1.) GO TO 1
      IF (ABS(RMAX).LT.999..AND.ABS(RMIN).LT.999.) GO TO 5
C scaled labeling
C (5-character true value decimal labels are not precise or are too small)
 1    DO 2 N=1,NINT
 2    WRITE(LBS(N),3) N
 3    FORMAT(I2)
      GO TO 10
C true value labels
 5    TMP=RMIN
      TEMP=(RMAX-RMIN)/NINT
      DO 7 N=1,NINT
      TMP=TMP+TEMP
 7    WRITE(LBS(N),8) TMP
 8    FORMAT(F6.1)
 10   WRITE(25) NINT,(LBS(N),N=1,NINT)

      FNORM=NINT/(RMAX-RMIN)
      LZERO=0
C DRAW ZERO LINE FOR VORTICITY
C     IF (FN.EQ.'S') LZERO=1
      DO 14 J=JL,JH
      DO 14 I=IL,IH
 14   MASK(I,J)=0
      IHM=IH-1
      JHM=JH-1
      F0=-RMIN*FNORM
C STORE NORMALIZED BOTTOM ROW INTO SCLN (0.LT.SCLN.LT.NINT)
C CONTOURS ARE DRAWN FOR SCLN=1,2,...,NINT-1 AND ARE LABELED BY INTEGER VALUES
C A KEY THEN GIVES THE ACTUAL (UNNORMALIZED) VALUE OF THE CONTOUR
      DO 20 I=IL,IH
 20   SCLN(I,1)=(FLD(I,JL)-RMIN)*FNORM
      N21=1
      N22=2
C CONTOUR ROW BY ROW
      DO 1000 J=JL,JHM
      DO 21 I=IL,IH
 21   SCLN(I,N22)=(FLD(I,J+1)-RMIN)*FNORM
C CALCULATE MAX AND MIN OF EACH VERTICAL SEGMENT IN THE ROW
C ON SCALAR COMPUTERS USE SEGMX(I)=MAX(SCLN(I,1),SCLN(I,2))
      DO 26 I=IL,IH
      SEGMX(I)=SCLN(I,1)
      SEGMN(I)=SCLN(I,1)
      SEGMX(I)=MAX(SEGMX(I),SCLN(I,2))
 26   SEGMN(I)=MIN(SEGMN(I),SCLN(I,2))
C CALCULATE MAX AND MIN OF EACH CELL IN THE ROW
C ON SCALAR COMPUTERS USE CELMX(I)=MAX(SEGMX(I),SEGMX(I+1))
      DO 36 I=IL,IHM
      CELMX(I)=SEGMX(I)
      CELMN(I)=SEGMN(I)
      CELMX(I)=MAX(CELMX(I),SEGMX(I+1))
 36   CELMN(I)=MIN(CELMN(I),SEGMN(I+1))
C ELIMINATE POSSIBLE ROUNDOFF PROBLEMS IN CELL
C     R=CELMX(I)-CELMN(I)
C     N=MIN(R/1.E-3,1.)
C36   CELMX(I)=CELMN(I)+N*R
      IF (LZERO.EQ.0) GO TO 38
      DO 37 I=IL,IHM
 37   ZERO(I)=MAX(0.,(CELMX(I)-F0)*(CELMN(I)-F0))
C CONVERT MAX AND MIN TO CONTOUR INTERVAL NUMBER
 38   IF (XBRD.NE.0.) GO TO 41
      DO 40 I=IL,IHM
C VORTICITY POINTS (CELL CORNERS)
      N=IN(I+1,J+1)
      ZERO(I)=ZERO(I)+2-N-LZERO
      MXCEL(I)=N*INT(CELMX(I))
 40   MNCEL(I)=N*INT(CELMN(I))
      GO TO 50
 41   DO 42 I=IL,IHM
C CELL-CENTERED POINTS
      N=IN(I,J)*IN(I+1,J)*IN(I,J+1)*IN(I+1,J+1)
      ZERO(I)=ZERO(I)+2-N-LZERO
      MXCEL(I)=N*INT(CELMX(I))
 42   MNCEL(I)=N*INT(CELMN(I))
C CONTOURING LOOP FOR CURRENT ROW
 50   DO 100 I=IL,IHM
C NO CONTOURS ENTER CELL IF MXCEL.EQ.MNCEL
      IF (MXCEL(I).EQ.MNCEL(I)) GO TO 100
C     IF (MXCEL(I).EQ.MNCEL(I).AND.ZERO(I).NE.0.) GO TO 100
      ID=I-IL
      JD=J-JL
C STORE SOUTHWEST, SOUTHEAST, NORTHWEST, AND NORTHEAST GRID VALUES
      FSW=SCLN(I,N21)
      FSE=SCLN(I+1,N21)
      FNW=SCLN(I,N22)
      FNE=SCLN(I+1,N22)
C DO CONTOUR DRAWING ONLY FOR CONTOUR VALUES MNCEL+1,MNCEL+2,...,MXCEL
      NLO=MNCEL(I)+1
      NHI=MXCEL(I)
      NHIP=NHI
C     IF (ZERO(I).EQ.0..AND.LZERO.EQ.1) NHIP=NHI+1
      DO 90 N=NLO,NHIP
      R=REAL(N)
      IF (N.GT.NHI) R=F0
C USE LINEAR INTERPOLATION TO DETERMINE WHICH OF THE FOUR SIDES OF CELL(I,J) IS
C CROSSED BY THE NORMALIZED VALUE N CONTOUR, AND DRAW CONTOUR SEGMENTS.
C DETERMINE EACH CONTOUR INTERSECTION WITH CELL SIDES AND STORE IN (XPT,YPT).
      NPT=0
C CHECK SOUTH CELL SIDE
      IF (R.GE.MAX(FSW,FSE).OR.R.LE.MIN(FSW,FSE)) GO TO 52
      NPT=NPT+1
      XPT(NPT)=ID+(R-FSW)/(FSE-FSW)
      YPT(NPT)=JD
C CHECK NORTH CELL SIDE
  52  IF (R.GE.MAX(FNW,FNE).OR.R.LE.MIN(FNW,FNE)) GO TO 54
      NPT=NPT+1
      XPT(NPT)=ID+(R-FNW)/(FNE-FNW)
      YPT(NPT)=JD+1
C CHECK WEST CELL SIDE
  54  IF (R.GE.MAX(FSW,FNW).OR.R.LE.MIN(FSW,FNW)) GO TO 56
      NPT=NPT+1
      XPT(NPT)=ID
      YPT(NPT)=JD+(R-FSW)/(FNW-FSW)
C CHECK EAST CELL SIDE
  56  IF (R.GE.MAX(FSE,FNE).OR.R.LE.MIN(FSE,FNE)) GO TO 60
      NPT=NPT+1
      XPT(NPT)=ID+1
      YPT(NPT)=JD+(R-FSE)/(FNE-FSE)
C NORMALLY, ONLY ONE SEGMENT OF CONTOUR VALUE N WILL EXIST IN CELL.  IN SUCH
C CASE, THE CONTOUR CROSSES ONLY TWO SIDES OF CELL(I,J), AND NPT=2 HERE.
 60   IF (NPT.NE.2) GO TO 90
      DO 70 NPT=1,2
      XPT(NPT)=XPT(NPT)+XBRD
 70   YPT(NPT)=YPT(NPT)+YBRD
C LABELING FLAG
      XC=.5*(XPT(1)+XPT(2))
      YC=.5*(YPT(1)+YPT(2))
      C=(XC-ID-1.)**2+(YC-JD-1.)**2
      IF (R.GT.F0.OR.J.LT.K0/3) GO TO 75
C DASH NEGATIVE CONTOURS
      XPT(2)=XPT(1)+.75*(XPT(2)-XPT(1))
      YPT(2)=YPT(1)+.75*(YPT(2)-YPT(1))
CPLT DRAW SEGMENT CONNECTING (XPT(1),YPT(1)) TO (XPT(2),YPT(2)).
 75   CALL GRAPH(XPT,YPT)
      NCN(LINES)=N
      IF (MASK(I,J).EQ.1.OR.NLO.NE.NHIP) GO TO 90
      IF (C.GT.EPS) GO TO 90
C TRIGGER FOR LABELS IS NEGATIVE VALUE OF NCN
      NCN(LINES)=-N
      JA=J
      JB=MIN(J+JMSK,JHM)
      IA=MAX(I-IMSK,IL)
      IB=MIN(I+IMSK,IHM)
      DO 80 JJ=JA,JB
      DO 80 II=IA,IB
 80   MASK(II,JJ)=1
 90   CONTINUE
 100  CONTINUE
      I=N21
      N21=N22
 1000 N22=I
      END
C ---------------------------------------------------------------------
      SUBROUTINE VECPL(U,W,IN,IL,KL,IH,KH)
C ---------------------------------------------------------------------
      INCLUDE '../resolution.h'
      PARAMETER(L0=9999,I1=I0-1,I2=I0-2,I3=I0-3,
     1 J1=J0-1,J2=J0-2,J3=J0-3,K1=K0-1,K2=K0-2,K3=K0-3)
      INTEGER*2 NX1,NX2,NZ1,NZ2,NCN,IN
      DIMENSION U(I0,*),W(I0,*)
      COMMON/FIXED/ODX(J0),ODY(J0),Z(K0+K1),ODZ(K1),ODZW(K0)
      COMMON/CON/TIME,FMIN,FMAX,IMN,KMN,IMX,KMX
      COMMON/LINSAV/XLO,XHI,ZLO,ZHI,XCON,ZCON,LINES,MAXCV,
     1 NX1(L0),NX2(L0),NZ1(L0),NZ2(L0),NCN(L0)
      DIMENSION XS(I0),XE(I0),ZS(I0),ZE(I0),AX(I0),AZ(I0),BX(I0),BZ(I0),
     1 CX(I0),CZ(I0),SEGMX(I0),X2PT(2,I0+K0),Z2PT(2,I0+K0),IN(I0,1)
      KHM=KH-1
      FMAX=0.
      DO 5 K=KL,KH
      DO 5 I=IL,IH
 5    FMAX=MAX(FMAX,U(I,K)**2+W(I,K)**2)
      FMAX=SQRT(FMAX)
      DO 7 I=IL,IH
 7    SEGMX(I)=MAX(ABS(U(I,KL))*ODX(J),ABS(W(I,KL)*ODZ(K)))
      DO 8 K=KL,KHM
      DO 8 I=IL,IH
 8    SEGMX(I)=MAX(SEGMX(I),ABS(U(I,K+1)*ODX(J)),ABS(W(I,K+1)*ODZ(K)))
      SMAX=SEGMX(1)
      DO 10 I=IL,IH
 10   SMAX=MAX(SMAX,SEGMX(I))
      IF (SMAX.EQ.0.) RETURN
      SIZ=2.
      UNRM=SIZ/SMAX
CPLT DRAW VECTOR FROM POINT (XS(I),ZS(I)) TO POINT (XE(I),ZE(I))
C TIP=(TIP LENGTH)/(SHAFT LENGTH); WD=(TIP WIDTH)/(TIP LENGTH)
      TIP=.5
      WD=.5
      TIP=TIP*UNRM
      IM=1
      DO 100 K=KL,KH,2
      IM=1-IM
      ILO=IL+IM
      KD=K-KL
      DO 90 I=ILO,IH,2
      XS(I)=I-IL
      ZS(I)=KD
      XE(I)=XS(I)+UNRM*U(I,K)*ODX(J)
      ZE(I)=ZS(I)+UNRM*W(I,K)*ODZ(K)
C TIP LENGTH SETMENT ALONG SHAFT (DX=TIP*U(I,K), DZ=TIP*W(I,K))
      DXT=TIP*U(I,K)*ODX(J)
      DZT=TIP*W(I,K)*ODZ(K)
      AX(I)=XE(I)-DXT
      AZ(I)=ZE(I)-DZT
C TIP WIDTH SEGMENT NORMAL TO SHAFT
      DXN=WD*DZT
      DZN=-WD*DXT
      BX(I)=AX(I)+DXN
      BZ(I)=AZ(I)+DZN
      CX(I)=AX(I)-DXN
 90   CZ(I)=AZ(I)-DZN
      DO 100 I=ILO,IH,2
      IF (IN(I,K).EQ.0) GO TO 100
C DRAW SHAFT
      X2PT(1,I)=XS(I)+.5
      X2PT(2,I)=XE(I)+.5
      Z2PT(1,I)=ZS(I)+.5
      Z2PT(2,I)=ZE(I)+.5
      CALL GRAPH(X2PT(1,I),Z2PT(1,I))
      NCN(LINES)=0
C DRAW ARROWHEAD
      X2PT(1,I)=BX(I)+.5
      Z2PT(1,I)=BZ(I)+.5
      CALL GRAPH(X2PT(1,I),Z2PT(1,I))
      NCN(LINES)=0
      X2PT(1,I)=CX(I)+.5
      Z2PT(1,I)=CZ(I)+.5
      CALL GRAPH(X2PT(1,I),Z2PT(1,I))
      NCN(LINES)=0
 100  CONTINUE
      END
C ----------------------------------------------------------------------
      SUBROUTINE INPUT(NPLOT,FLD,FN,J,FNAME)
C ----------------------------------------------------------------------
      INCLUDE '../resolution.h'
      PARAMETER(L0=9999,I1=I0-1,I2=I0-2,I3=I0-3,
     1 J1=J0-1,J2=J0-2,J3=J0-3,K1=K0-1,K2=K0-2,K3=K0-3)
      CHARACTER FN*1,FNAME*30
      INTEGER*2 NFLD,NX1,NX2,NZ1,NZ2,NCN
      COMMON/FIXED/ODX(J0),ODY(J0),Z(K0+K1),ODZ(K1),ODZW(K0)
      DIMENSION NFLD(I0,K1),FLD(I0,1)
      COMMON/LINSAV/XLO,XHI,ZLO,ZHI,XCON,ZCON,LINES,MAXCV,
     1 NX1(L0),NX2(L0),NZ1(L0),NZ2(L0),NCN(L0)
      COMMON/CON/TIME,FMIN,FMAX,IMN,KMN,IMX,KMX
      READ(31,END=999) FN,FNAME,TIME,J,IMN,KMN,IMX,KMX,FMIN,FMAX,
     1 ((NFLD(I,K),I=2,I1),K=K1,1,-1)
      WRITE(*,15) FN,J,TIME,FMIN,FMAX
 15   FORMAT(A1,' @ J=',I3,' ,t=',F8.2,'. mn= ',1PE9.2,', mx= ',1PE9.2)
C FLD=FMIN+NFLD*(FMAX-FMIN)/9999.
      RF=(FMAX-FMIN)/9999.
      DO 105 K=1,K1
      DO 105 I=2,I1
 105  FLD(I,K)=FMIN+RF*NFLD(I,K)
      RETURN
 999  CONTINUE
      WRITE(4,1000) MAXCV,NPLOT
      WRITE(*,1000) MAXCV,NPLOT
 1000 FORMAT('N1= ',I4,' (LINES IN LONGEST CONVEC PLOT)'/
     1 'NP= ',I4,' (NUMBER OF PLOT FRAMES)')
      STOP
      END
C ----------------------------------------------------------------------
      SUBROUTINE GRAPH(X,Z)
C ----------------------------------------------------------------------
      INCLUDE '../resolution.h'
      PARAMETER(L0=9999)
      CHARACTER*1 FYZ
      INTEGER*2 NX1,NX2,NZ1,NZ2,NCN
      COMMON/PHYS/FYZ
      COMMON/LINSAV/XLO,XHI,ZLO,ZHI,XCON,ZCON,LINES,MAXCV,
     1 NX1(L0),NX2(L0),NZ1(L0),NZ2(L0),NCN(L0)
      COMMON/TRANZ/ZW(K0),ZFYZ
      DIMENSION X(*),Z(*)
C  INPUT:
C  X(1): BEGIN LINE X-COORDINATE
C  Z(1): BEGIN LINE Z-COORDINATE
C  X(1):   END LINE X-COORDINATE
C  Z(1):   END LINE Z-COORDINATE
      LINES=LINES+1
      IF (LINES.GT.L0) GO TO 100
      IF (FYZ.EQ.'N') GO TO 90
C TRANSFORM TO PHYSICAL SPACE. ZFYZ=ZHI/Z(K0+K1)
C SAVE INPUTS
      Z1=Z(1)
      Z2=Z(2)
      L=Z(1)+1.
      Z(1)=(ZW(L)+(Z(1)+1.-L)*(ZW(L+1)-ZW(L)))*ZFYZ
      L=Z(2)+1.
      Z(2)=(ZW(L)+(Z(2)+1.-L)*(ZW(L+1)-ZW(L)))*ZFYZ
 90   NX1(LINES)=(X(1)-XLO)*XCON
      NX2(LINES)=(X(2)-XLO)*XCON
      NZ1(LINES)=(Z(1)-ZLO)*ZCON
      NZ2(LINES)=(Z(2)-ZLO)*ZCON
C     NLO=MIN(NX1(LINES),NX2(LINES),NZ1(LINES),NZ2(LINES))
C     NHI=MAX(NX1(LINES),NX2(LINES),NZ1(LINES),NZ2(LINES))
C     IF (NLO.GE.0.AND.NHI.LE.9999) GO TO 90
C     WRITE(*,80) NX1(LINES),NX2(LINES),NZ1(LINES),NZ2(LINES),
C    1 X(1),X(2),Z(1),Z(2),XCON,ZCON,XLO,ZLO
C80   FORMAT(' NX1,NX2,NZ1,NZ2',4I6/'X1,X2,Z1,Z2,XCON,ZCON,XLO,ZLO',
C    1 8(1X,F7.1))
C     STOP
C90   CONTINUE
      Z(1)=Z1
      Z(2)=Z2
      RETURN
 100  WRITE(4,101) L0
      WRITE(*,101) L0
 101  FORMAT(' LINES.GT.L0(=',I5,').  INCREASE L0 PARAMETER TO ALLOW MOR
     1E LINES PER RECORD BEFORE RESTART.  STOP.')
      STOP
      END
