      PROGRAM PLOTS
C THIS VERSION BRINGS NP PLOTS FROM HARD DISK TO CORE
C THEN PRODUCES INDIVIDUAL SCREEN PLOTS WITH POSTSCRIPT HARD COPY OPTIONS
      INCLUDE '../resolution.h'
      PARAMETER(M0=62,L0=3940,LB0=99,N1=9999,NP=88,J1=J0-1)
      INTEGER*2 NGL,NOL,NCV
      CHARACTER TITLE*88
      CHARACTER*50 NAME(NP)

C This must be consistent with plot0.f!
      CHARACTER*6 LBS(LB0,NP)
      CHARACTER*1 FN(NP)
      CHARACTER*1 TURN,JUNK
C NP= TOTAL NUMBER OF PLOT FRAMES TO BE STORED AND VIEWED
C M0= NUMBER OF LINES NEEDED FOR GRID TICK MARK LINES
C L0= NUMBER OF LINES NEEDED FOR OBSTACLE CROSS-HATCH AND STAIRCASE LINES
C N1= NUMBER OF LINES NEEDED FOR CONTOUR AND VECTOR PLOTS
C NGL IS GRID TICKS ARRAY
C NOL IS CROSS-HATCHED OBSTACLES LINES ARRAY
C NCV IS CONTOUR LINES ARRAY FOR ALL CONTOUR AND VECTOR PLOTS
C 
C RANGE OF LINES ARRAYS IS ASSUMED TO BE 0 TO 9999
      DIMENSION
     1 NGL(M0,4),NOL(L0,4,J1),LC(J1),NCV(N1,5,NP),NINT(NP),JY(NP),
     2LCV(NP),TIME(NP),FMIN(NP),FMAX(NP),IMN(NP),JMN(NP),IMX(NP),JMX(NP)
      COMMON/FIXED/NW,NOCOL
      COMMON/ZOOM/LX,LY,XA,XB,YA,YB,ZUMX,ZERX,ZUMY,ZERY
      COMMON/MAP/XMAP0,XMAP1,YMAP0,YMAP1,XSCALE,YSCALE,NPOST
      DATA TURN/'n'/
      PRINT*,'LPOST=0 FOR ALL SCREEN PLOTS AND NO POSTSCRIPT PLOTS'
      PRINT*,'LPOST=1 FOR POSTSCRIPT PLOT OPTION AFTER PREVIEWING EACH S
     1CREEN PLOT'
      PRINT*,'LPOST=2 FOR ALL POSTSCRIPT PLOTS AND NO SCREEN PLOTS'
      PRINT*,'ENTER DESIRED LPOST VALUE (0,1,2)'
      READ(*,10) LPOST
 10   FORMAT(I1)
C SET DEFAULT LPOST VALUE
      IF (LPOST.NE.0.AND.LPOST.NE.1.AND.LPOST.NE.2) LPOST=1
      LX=1
      LY=1
C ZOOM WINDOW (FRACTION OF TOTAL PHYSICAL REGION)
C Denmark Strait
      XA=.385
      XB=.605
C Upper 1000 m
      YA=0.8
      YB=1.
C FULL depth
      YA=0.
      YB=1.
      ZUMX=1./(XB-XA)
      ZERX=XA*9999.
      ZUMY=1./(YB-YA)
      ZERY=YA*9999.
 11   FORMAT(A1)
      IF (TURN.EQ.'y') PRINT*, 'Plots are rotated 90 degrees.'
      IF (TURN.EQ.'n') PRINT*, 'Plot are not rotated.'
      OPEN(24,file='GRID',form='unformatted')
      OPEN(34,file='OBSTACLES',form='unformatted')
      OPEN(25,file='CONVEC',form='unformatted')
      REWIND 24
      REWIND 25
      REWIND 34
C POSTSCRIPT FILE
      IF (LPOST.NE.0) OPEN(50,file='ps.dat')
      IF (LPOST.NE.0) REWIND 50
      READ(24) LB,((NGL(N,L),L=1,4),N=1,LB)
      DO 52 J=2,J1
      READ(34) LJ,((NOL(N,L,J),L=1,4),N=1,LJ)
 52   LC(J)=LJ
 53   CLOSE(24)
      CLOSE(34)
      LJ=0
      DO 54 J=2,J1
 54   LJ=MAX(LJ,LC(J))
      IF (LB.LE.M0) GO TO 57
      WRITE(*,56) LB,M0
 56   FORMAT(I5,' GRID LINES READ INTO ',I5,'-LINE GL ARRAY. ARRAY IS UN
     1DER-DIMENSIONED. STOP')
      STOP
 57   IF (LJ.LE.L0) GO TO 59
      WRITE(*,58) LJ,L0
 58   FORMAT(I5,' OBST LINES READ INTO ',I5,'-LINE OL ARRAY. ARRAY IS UN
     1DER-DIMENSIONED. STOP')
      STOP
 59   DO 70 NF=1,NP
      READ(25,END=71) NINT(NF),(LBS(N,NF),N=1,NINT(NF))
      READ(25,END=71) JY(NF),FN(NF),NAME(NF),
     1 TIME(NF),FMIN(NF),FMAX(NF),IMN(NF),JMN(NF),IMX(NF),JMX(NF),
     2 NINT(NF),LINES,((NCV(N,L,NF),L=1,5),N=1,LINES)
      WRITE(*,61) FN(NF),TIME(NF),FMIN(NF),FMAX(NF)
 61   FORMAT(A1,' @ time= ',F9.1,'days. mn= ',1PE9.2,', mx= ',1PE9.2)
      LCV(NF)=LINES
      IF (LINES.LE.N1) GO TO 70
      WRITE(*,62) LINES,N1
 62   FORMAT(I5,' LINES READ INTO ',I5,'-LINE NCV ARRAY.  NCV IS UNDER-
     1DIMENSIONED. STOP.')
      STOP
 70   CONTINUE
 71   IF (NF.EQ.1) STOP
      CLOSE(25)
      NCOR=NF-1
C USER WINDOW COORDINATES ARE NORMALIZED INTEGERS SUCH THAT
C 0.LE.X.LE.9999 AND 0.LE.Y.LE.9999
      XMAP0=0.
      XMAP1=9999.
      YMAP0=0.
      YMAP1=9999.
C POST SCRIPT HARD COPY SCALING PARAMETERS
C LEAVE X AND Y UNITS AS POST SCRIPT DEFAULT, 1/72 INCH
C WITH STANDARD (90 DEGREE ROTATED) PAGE SIZE (11 X 8.5 INCHES)
C Full page
      XSCALE=11.*72./(XMAP1-XMAP0)
      YSCALE=8.5*72./(YMAP1-YMAP0)
C SCREEN SCALING PARAMETERS    
      CALL WINDOW(NW,XMAP0,XMAP1,YMAP0,YMAP1)
C BLACK BACKGROUND
      CALL RGBCOL(0,0,0)
      CALL CLEAR
 80   DO 950 NF=1,NCOR
C     IF (TIME(NF).LT.3901.) GO TO 950
      J=JY(NF)
      IF (LPOST.EQ.2) GO TO 90
      PRINT*,'hit enter key for new plot'
      READ(*,11) JUNK
      NPOST=0
 90   IF (LPOST.EQ.2) NPOST=1
 100  IF (NPOST.EQ.1) WRITE(50,105)
 105  FORMAT('%!'/'576 46 translate 90 rotate .9 .9 scale'/
     1 '/Times-Roman findfont'/
     2 '15 scalefont'/'setfont')
C105  FORMAT('%!'/'36 46 translate .9 .9 scale'/
C    1 '/Times-Roman findfont'/
C    2 '12 scalefont'/'setfont'/'1 setlinewidth 0 setgray')
      IF (NPOST.EQ.1) GO TO 115
COLORS
C black background
      CALL RGBCOL(0,0,0)
      CALL CLEAR
C white tickmarks and bottom for screen plots
      CALL RGBCOL(255,255,255)
      CALL LINEWI(1)
      GO TO 120

C Postscript black background
 115  WRITE(50,116)
 116  FORMAT('1280 setlinewidth 0.0 0.0 0.0 setrgbcolor'/
     1 ' -50  -50 moveto'/
     2 '1280  -50 lineto'/
     3 '1280 1100 lineto'/
     5 ' -50 1100 lineto'/
     6 'closepath'/
     7 'stroke')

      IF (NPOST.EQ.1) WRITE(50,117)
 117  FORMAT('1 setlinewidth 1.0 1.0 1.0 setrgbcolor')

C NCV is not used unless GRAF argument #2 is zero
 120  IF (TURN.NE.'y') CALL GRAF(LBS(1,NF),
     1 1,NCV,NGL(1,1),NGL(1,3),NGL(1,2),NGL(1,4),LB)
      IF (TURN.EQ.'y') CALL GRAF(LBS(1,NF),
     1 1,NCV,NGL(1,3),NGL(1,1),NGL(1,4),NGL(1,2),LB)

      IF (TURN.NE.'y') CALL GRAF(LBS(1,NF),
     1 1,NCV,NOL(1,1,J),NOL(1,3,J),NOL(1,2,J),NOL(1,4,J),LC(J))
      IF (TURN.EQ.'y') CALL GRAF(LBS(1,NF),
     1 1,NCV,NOL(1,3,J),NOL(1,1,J),NOL(1,4,J),NOL(1,2,J),LC(J))

      IF (NPOST.EQ.1) WRITE(50,122)
 122  FORMAT('2 setlinewidth')
      CALL LINEWI(2)

      YEARS=TIME(NF)/360.
      NYEAR=YEARS
      NDAY=(YEARS-NYEAR)*360.+0.5
      WRITE(TITLE,125) NAME(NF),NDAY,NYEAR+1,FMIN(NF),FMAX(NF)
 125  FORMAT(A50,' @ day',I4,', yr',I3,'. lo=',F6.1,', hi=',F5.1)

      IF (NPOST.NE.1) GO TO 130
C LOCATION OF FIRST POSTSCRIPT CHARACTER
      NXPOST=80*XSCALE
      NYPOST=100*YSCALE
C black Postscript title
      WRITE(50,126)
 126  FORMAT('1.0 1.0 1.0 setrgbcolor')
      WRITE(50,127) NXPOST,NYPOST,TITLE
 127  FORMAT(/2I5,' moveto'/'(',A88,')',' show')
      GO TO 945

C white screen title
 130  CALL RGBCOL(255,255,255)
      CALL CMOV2I(80,200,0)
      CALL CHARST(TITLE,88)
      NOCOL=0
 945  IF (TURN.NE.'y') CALL GRAF(LBS(1,NF),NOCOL,NCV(1,5,NF),
     1NCV(1,1,NF),NCV(1,3,NF),NCV(1,2,NF),NCV(1,4,NF),LCV(NF))
      IF (TURN.EQ.'y') CALL GRAF(LBS(1,NF),NOCOL,NCV(1,5,NF),
     1NCV(1,3,NF),NCV(1,1,NF),NCV(1,4,NF),NCV(1,2,NF),LCV(NF))

      IF (NPOST.NE.1) GO TO 948
      WRITE(50,947)
 947  FORMAT('showpage')
      GO TO 950
 948  IF (LPOST.NE.1) GO TO 950
      PRINT*,'Make hardcopy? (y,n)'
      READ(*,11) JUNK
      IF (LPOST.NE.1.OR.NPOST.EQ.1.OR.JUNK.NE.'y') GO TO 950
      NPOST=1
      GO TO 100
 950  CONTINUE
      IF (LPOST.NE.1) GO TO 80
      CALL WINCLO(NW)
      END
C ----------------------------------------------------------------------
      SUBROUTINE GRAF(LBS,NOCOL,NCN,NX1,NY1,NX2,NY2,LINES)
C ----------------------------------------------------------------------
      INTEGER*2 NCN,NX1,NX2,NY1,NY2
      CHARACTER*6 LBS(*)
      DIMENSION NCN(*),NX1(*),NX2(*),NY1(*),NY2(*),P(2),T(2)
      COMMON/ZOOM/LX,LY,XA,XB,YA,YB,ZUMX,ZERX,ZUMY,ZERY
      COMMON/RASTERS/IRAST0,IRAST1,JRAST0,JRAST1
      COMMON/MAP/XMAP0,XMAP1,YMAP0,YMAP1,XSCALE,YSCALE,NPOST

C NOCOL=1 means no color change in GRAF !
C roygbiv, with or without color recycling

      DIMENSION NC1(7),NC2(7),NC3(7)
C vectors are from NC=1, black background
C violet = 125,0,125
C indigo = 255,0,255
C blue = 0,0,255
C green = 0,255,0
C yellow = 255,255,0
C orange = 255,128,0
C red = 255,0,0
C ? = 150,100,20
      DATA NC1/125,255,  0,  0,255,255,255/
      DATA NC2/  0,  0,  0,255,255,128,  0/
      DATA NC3/125,255,255,  0,  0,  0,  0/

      MN=10000
      MX=0
      DO 1111 N=1,LINES
      MN=MIN(MN,ABS(NCN(N)))
 1111 MX=MAX(MX,ABS(NCN(N)))
C 7 colors
      RMX=6.9/(MX-MN)

C draw the lines
      DO 100 N=1,LINES
      NCC=ABS(NCN(N))
C 7 colors (roygbiv)
C recycling
C     NC=MOD(NCC,7)+1
C no recycling
      NC=(NCC-MN)*RMX+1
      IF (LX.EQ.0) GO TO 5
      P(1)=ZUMX*(NX1(N)-ZERX)
      T(1)=ZUMX*(NX2(N)-ZERX)
C plot only points inside window
      IF (P(1).LT.0..OR.T(1).LT.0..OR.P(1).GT.9999..OR.T(1).GT.9999.)
     1 GO TO 100
      GO TO 6
 5    P(1)=NX1(N)
      T(1)=NX2(N)
 6    IF (LY.EQ.0) GO TO 7
      P(2)=ZUMY*(NY1(N)-ZERY)
      T(2)=ZUMY*(NY2(N)-ZERY)
      IF (P(2).LT.0..OR.T(2).LT.0..OR.P(2).GT.9999..OR.T(2).GT.9999.)
     1 GO TO 100
      GO TO 8
 7    P(2)=NY1(N)
      T(2)=NY2(N)
 8    IF (NCN(N).LT.0) GO TO 50
      IF (NPOST.NE.1) GO TO 40

Color Postscript command
      IF (NOCOL.EQ.1) GO TO 20
      C1=NC1(NC)/255.
      C2=NC2(NC)/255.
      C3=NC3(NC)/255.
      WRITE(50,10) C1,C2,C3
 10   FORMAT(3F7.4,' setrgbcolor')
 20   NXPOST1=XSCALE*P(1)
      NXPOST2=XSCALE*T(1)
      NYPOST1=YSCALE*P(2)
      NYPOST2=YSCALE*T(2)
      WRITE(50,30) NXPOST1,NYPOST1,NXPOST2,NYPOST2
 30   FORMAT(2I5,' moveto'/2I5,' lineto'/'stroke')
      GO TO 100
 40   IF (NOCOL.EQ.0) CALL RGBCOL(NC1(NC),NC2(NC),NC3(NC))
      CALL BGNLIN
      CALL V2F(P)
      CALL V2F(T)
      CALL ENDLIN
      GO TO 100
C SW CORNER OF CHARACTER IS AT NXC,NYC
 50   NXC=.5*(P(1)+T(1))
      NYC=.5*(P(2)+T(2))
C SW CORNER OF CHARACTER IS AT SW CELL CORNER
C     NXC=NX1(N)
C     NYC=NY1(N)
      IF (NPOST.NE.1) GO TO 80
      NXPOST=NXC*XSCALE
      NYPOST=NYC*YSCALE
      WRITE(50,70) NXPOST,NYPOST,LBS(NCC)
 70   FORMAT(2I5,' moveto'/'(',A6,')',' show')
      GO TO 100
 80   IF (NOCOL.EQ.0) CALL RGBCOL(NC1(NC),NC2(NC),NC3(NC))

C TRANSFORM LOCATION FROM USER TO RASTER COORDINATES
C     IRST=IRAST0+(NXC-XMAP0)/(XMAP1-XMAP0)*(IRAST1-IRAST0)
C     JRST=JRAST0+(NYC-YMAP0)/(YMAP1-YMAP0)*(JRAST1-JRAST0)
C     CALL CMOV2I(IRST,JRST,0)

      CALL CMOV2I(NXC,NYC,0)
      CALL CHARST(LBS(NCC),6)
 100  CONTINUE
      END
C ----------------------------------------------------------------------
      SUBROUTINE WINDOW(NW,XMIN,XMAX,YMIN,YMAX)
C ----------------------------------------------------------------------
      COMMON/ZOOM/LX,LY,XA,XB,YA,YB,ZUMX,ZERX,ZUMY,ZERY
      COMMON/RASTERS/IRAST0,IRAST1,JRAST0,JRAST1
      INTEGER WINOPE
      TMP=1.
      IRAST0=10
      IRAST1=TMP*1200
      JRAST0=30
      JRAST1=1020
C CREATE THE WINDOW IN RASTER COORDINATES
      CALL PREFPO(IRAST0,IRAST1,JRAST0,JRAST1)
      CALL NOBORD
      CALL FOREGR
C NAME THE WINDOW
      NW= WINOPE( "PLOT",1 )
C For full color range
      CALL RGBMOD
      CALL SINGLE
      CALL GCONFI
C SCALE THE WINDOW IN USER COORDINATES
      CALL ORTHO2(XMIN,XMAX,YMIN,YMAX)
      END
